import { Facet } from "@codemirror/state";
// Feature toggle facets
export const diagnosticsEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
export const hoverEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
export const completionEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
export const definitionEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
export const renameEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
export const codeActionsEnabled = Facet.define({
    combine: (values) => allTrue(values),
});
function allTrue(values) {
    // If no values are provided, default to true
    if (values.length === 0) {
        return true;
    }
    return values.every((value) => value);
}
export function createUseLastOrThrow(message) {
    const fallback = new Proxy({}, {
        get() {
            throw new Error(message);
        },
    });
    return function useLastOrThrow(values) {
        return values.at(-1) ?? fallback;
    };
}
export const languageServerClient = Facet.define({
    combine: createUseLastOrThrow("No language server client provided. Either pass a one into the extension or use languageServerClient.of()."),
});
export const documentUri = Facet.define({
    combine: createUseLastOrThrow("No document URI provided. Either pass a one into the extension or use documentUri.of()."),
});
export const languageId = Facet.define({
    combine: createUseLastOrThrow("No language ID provided. Either pass a one into the extension or use languageId.of()."),
});
//# sourceMappingURL=config.js.map